Package org.gradle.api.tasks

# Interface TaskCollection<T extends Task>

Type Parameters:
  `T` - The type of tasks which this collection contains.

All Superinterfaces:
  `Collection<T>`, `DomainObjectCollection<T>`, `DomainObjectSet<T>`, `Iterable<T>`, `NamedDomainObjectCollection<T>`, `NamedDomainObjectSet<T>`, `Set<T>`

All Known Subinterfaces:
  `TaskContainer`

public interface TaskCollection<T extends Task> extends NamedDomainObjectSet<T>
A `TaskCollection` contains a set of `Task` instances, and provides a number of query methods.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `T`
  `getAt(String name)`
  Locates an object by name, failing if there is no such object.
  `T`
  `getByName(String name)`
  Locates an object by name, failing if there is no such object.
  `T`
  `getByName(String name, Closure configureClosure)`
  Locates an object by name, failing if there is no such object.
  `TaskCollection<T>`
  `matching(Closure closure)`
  Returns a collection which contains the objects in this collection which meet the given closure specification.
  `TaskCollection<T>`
  `matching(Spec<? super T> spec)`
  Returns a collection which contains the objects in this collection which meet the given specification.
  `TaskProvider<T>`
  `named(String name)`
  Locates a task by name, without triggering its creation or configuration, failing if there is no such object.
  `<S extends T>
  TaskProvider<S>`
  `named(String name, Class<S> type)`
  Locates a object by name and type, failing if there is no such object.
  `<S extends T>
  TaskProvider<S>`
  `named(String name, Class<S> type, Action<? super S> configurationAction)`
  Locates a object by name and type, failing if there is no such object.
  `TaskProvider<T>`
  `named(String name, Action<? super T> configurationAction)`
  Locates a object by name, failing if there is no such object.
  `TaskCollection<T>`
  `named(Spec<String> nameFilter)`
  Returns a collection containing the objects with names matching the provided filter.
  `void`
  `whenTaskAdded(Closure closure)`
  Adds a closure to be called when a task is added to this collection.
  `Action<? super T>`
  `whenTaskAdded(Action<? super T> action)`
  Adds an `Action` to be executed when a task is added to this collection.
  `<S extends T>
  TaskCollection<S>`
  `withType(Class<S> type)`
  Returns a collection containing the objects in this collection of the given type.

  ### Methods inherited from interface java.util.Collection

  `parallelStream, removeIf, stream, toArray`

  ### Methods inherited from interface org.gradle.api.DomainObjectCollection

  `addAllLater, addLater, all, all, configureEach, disallowChanges, whenObjectAdded, whenObjectAdded, whenObjectRemoved, whenObjectRemoved, withType, withType`

  ### Methods inherited from interface java.lang.Iterable

  `forEach`

  ### Methods inherited from interface org.gradle.api.NamedDomainObjectCollection

  `add, addAll, addRule, addRule, addRule, findByName, getAsMap, getByName, getCollectionSchema, getNamer, getNames, getRules`

  ### Methods inherited from interface org.gradle.api.NamedDomainObjectSet

  `findAll`

  ### Methods inherited from interface java.util.Set

  `add, addAll, clear, contains, containsAll, equals, hashCode, isEmpty, iterator, remove, removeAll, retainAll, size, spliterator, toArray, toArray`

- ## Method Details

  - ### named

    TaskCollection<T> named(Spec<String> nameFilter)
    Returns a collection containing the objects with names matching the provided filter. The returned collection is live, so that when matching objects are added to this collection, they are also visible in the filtered collection.

    This method is an intermediate operation. It does not change the realized/unrealized state of the elements in the collection.

    Specified by:
      `named` in interface `NamedDomainObjectCollection<T extends Task>`
    Specified by:
      `named` in interface `NamedDomainObjectSet<T extends Task>`
    Parameters:
      `nameFilter` - The specification to test names against.
    Returns:
      The collection of objects with names satisfying the filter. Returns an empty collection if there are no such objects in this collection.

  - ### matching

    TaskCollection<T> matching(Spec<? super T> spec)
    Returns a collection which contains the objects in this collection which meet the given specification. The returned collection is live, so that when matching objects are added to this collection, they are also visible in the filtered collection.

    This method is an intermediate eager operation. The application of the filter forces the realization of the collection elements.

    Specified by:
      `matching` in interface `DomainObjectCollection<T extends Task>`
    Specified by:
      `matching` in interface `DomainObjectSet<T extends Task>`
    Specified by:
      `matching` in interface `NamedDomainObjectCollection<T extends Task>`
    Specified by:
      `matching` in interface `NamedDomainObjectSet<T extends Task>`
    Parameters:
      `spec` - The specification to use.
    Returns:
      The collection of matching objects. Returns an empty collection if there are no such objects in this collection.

  - ### matching

    TaskCollection<T> matching(Closure closure)
    Returns a collection which contains the objects in this collection which meet the given closure specification. The returned collection is live, so that when matching objects are added to this collection, they are also visible in the filtered collection.

    This method is an intermediate eager operation. The application of the filter forces the realization of the collection elements.

    Specified by:
      `matching` in interface `DomainObjectCollection<T extends Task>`
    Specified by:
      `matching` in interface `DomainObjectSet<T extends Task>`
    Specified by:
      `matching` in interface `NamedDomainObjectCollection<T extends Task>`
    Specified by:
      `matching` in interface `NamedDomainObjectSet<T extends Task>`
    Parameters:
      `closure` - The specification to use. The closure gets a collection element as an argument.
    Returns:
      The collection of matching objects. Returns an empty collection if there are no such objects in this collection.

  - ### getByName

    T getByName(String name, Closure configureClosure) throws UnknownTaskException
    Locates an object by name, failing if there is no such object. The given configure closure is executed against the object before it is returned from this method. The object is passed to the closure as its delegate.

    This operation is eager and will cause the returned element to be realized.

    Specified by:
      `getByName` in interface `NamedDomainObjectCollection<T extends Task>`
    Parameters:
      `name` - The object name
      `configureClosure` - The closure to use to configure the object.
    Returns:
      The object with the given name, after the configure closure has been applied to it. Never returns null.
    Throws:
      `UnknownTaskException`

  - ### getByName

    T getByName(String name) throws UnknownTaskException
    Locates an object by name, failing if there is no such object.

    This operation is eager and will cause the returned element to be realized.

    Specified by:
      `getByName` in interface `NamedDomainObjectCollection<T extends Task>`
    Parameters:
      `name` - The object name
    Returns:
      The object with the given name. Never returns null.
    Throws:
      `UnknownTaskException`

  - ### withType

    <S extends T> TaskCollection<S> withType(Class<S> type)
    Returns a collection containing the objects in this collection of the given type. The returned collection is live, so that when matching objects are later added to this collection, they are also visible in the filtered collection.

    This method is an intermediate operation. It does not change the realized/unrealized state of the elements in the collection.

    Specified by:
      `withType` in interface `DomainObjectCollection<T extends Task>`
    Specified by:
      `withType` in interface `DomainObjectSet<T extends Task>`
    Specified by:
      `withType` in interface `NamedDomainObjectCollection<T extends Task>`
    Specified by:
      `withType` in interface `NamedDomainObjectSet<T extends Task>`
    Parameters:
      `type` - The type of objects to find.
    Returns:
      The matching objects. Returns an empty collection if there are no such objects in this collection.

  - ### whenTaskAdded

    Action<? super T> whenTaskAdded(Action<? super T> action)
    Adds an `Action` to be executed when a task is added to this collection.

    Like `DomainObjectCollection.all(Action)`, this method will cause all tasks in this container to be realized.

    Parameters:
      `action` - The action to be executed
    Returns:
      the supplied action

  - ### whenTaskAdded

    void whenTaskAdded(Closure closure)
    Adds a closure to be called when a task is added to this collection. The task is passed to the closure as the parameter.
    Parameters:
      `closure` - The closure to be called
    See Also:
      - `whenTaskAdded(Action)`

  - ### getAt

    T getAt(String name) throws UnknownTaskException
    Locates an object by name, failing if there is no such object. This method is identical to `NamedDomainObjectCollection.getByName(String)`. You can call this method in your build script by using the groovy `[]` operator.

    This operation is eager and will cause the returned element to be realized.

    Specified by:
      `getAt` in interface `NamedDomainObjectCollection<T extends Task>`
    Parameters:
      `name` - The object name
    Returns:
      The object with the given name. Never returns null.
    Throws:
      `UnknownTaskException`

  - ### named

    TaskProvider<T> named(String name) throws UnknownTaskException
    Locates a task by name, without triggering its creation or configuration, failing if there is no such object.
    Specified by:
      `named` in interface `NamedDomainObjectCollection<T extends Task>`
    Parameters:
      `name` - The task name
    Returns:
      A `Provider` that will return the task when queried. The task may be created and configured at this point, if not already.
    Throws:
      `UnknownTaskException` - If a task with the given name is not defined.
    Since:
      4.9

  - ### named

    TaskProvider<T> named(String name, Action<? super T> configurationAction) throws UnknownTaskException
    Locates a object by name, failing if there is no such object. The given configure action is executed against the object before it is returned from the provider.

    This method is lazy and will not cause the returned element to be realized.

    Specified by:
      `named` in interface `NamedDomainObjectCollection<T extends Task>`
    Parameters:
      `name` - The object's name
    Returns:
      A `Provider` that will return the object when queried. The object may be created and configured at this point, if not already.
    Throws:
      `UnknownTaskException`
    Since:
      5.0

  - ### named

    <S extends T> TaskProvider<S> named(String name, Class<S> type) throws UnknownTaskException
    Locates a object by name and type, failing if there is no such object.

    This method is lazy and will not cause the returned element to be realized.

    Specified by:
      `named` in interface `NamedDomainObjectCollection<T extends Task>`
    Parameters:
      `name` - The object's name
      `type` - The object's type
    Returns:
      A `Provider` that will return the object when queried. The object may be created and configured at this point, if not already.
    Throws:
      `UnknownTaskException`
    Since:
      5.0

  - ### named

    <S extends T> TaskProvider<S> named(String name, Class<S> type, Action<? super S> configurationAction) throws UnknownTaskException
    Locates a object by name and type, failing if there is no such object. The given configure action is executed against the object before it is returned from the provider.

    This method is lazy and will not cause the returned element to be realized.

    Specified by:
      `named` in interface `NamedDomainObjectCollection<T extends Task>`
    Parameters:
      `name` - The object's name
      `type` - The object's type
      `configurationAction` - The action to use to configure the object.
    Returns:
      A `Provider` that will return the object when queried. The object may be created and configured at this point, if not already.
    Throws:
      `UnknownTaskException`
    Since:
      5.0